#ifdef XEROX_MODIFICATION_SMB

/**************************************************************************
                            XEROX REVISION HISTORY

Date         Author                        Description
----------  -------------  -------------------------------------------------- 
07/09/2014  M Tompkins    CQGbl599972: Upgrade Samba to 4.0.7 took from kinit.c
06/22/2012  H Freiburg    CQGbl380680: Put convert_decimalString_to_char() into its
						  own file so it can also be used by the 'net' executable
**************************************************************************/

#include "includes.h"

#define NUMBER_OF_DECIMAL_DIGITS_FOR_A_CHAR     3

/**************************************************************
 static bool_t convert_decimalString_to_char(char *toConvertString,
                                             char *convertedString)

 PURPOSE: This function is used to convert a decimal representation
          of a string of characters back into a normal string of
          characters.

 RETURNS:
         True when the function is successful
         False otherwise.
 **************************************************************/
bool_t convert_decimalString_to_char(char *toConvertString,
                                      char *convertedString)
{
    char  decimalCharacter[NUMBER_OF_DECIMAL_DIGITS_FOR_A_CHAR + 2];
    char  convertedCharacter[2];
    int   decimalValue;
    int   i = 0;
    int   j = 0;
  
    /* If the in or out strings are null pointers, return FALSE */
    if ((toConvertString == NULL) || (convertedString == NULL))
    {
      return(False);
    }
  
    /* Convert the passed in string from encode decimal to characters */
    while(toConvertString[i] != '\0')
    {
      /* Ensure there will be a terminating NULL in decimalCharacter */
      memset(decimalCharacter,0,sizeof(decimalCharacter));
  
      /* Copy out the first decimal representation of a character */
      strncpy(decimalCharacter,&toConvertString[i],NUMBER_OF_DECIMAL_DIGITS_FOR_A_CHAR);
  
      /* Convert the decimal from string to an actual integer */
      decimalValue = atoi(decimalCharacter);
  
      /* Convert the decimal value back into a character */
      snprintf(convertedCharacter,sizeof(convertedCharacter),"%c",decimalValue);
  
      /* Put the new character in out output string */
      convertedString[j] = convertedCharacter[0];
  
      /* Increment the in and out string indexes */
      i = i + NUMBER_OF_DECIMAL_DIGITS_FOR_A_CHAR;
      j++;
    }
  
    /* Terminate the output string */
    convertedString[j] = '\0';
    return(True);
}
#endif /* XEROX_MODIFICATION_SMB */
